BLAKE2s Class Reference

The BLAKE2s cryptographic hash function. More...

Inheritance diagram for BLAKE2s:

## Public Types

typedef BLAKE2_Base< word32, false > | ThisBase
typedef BLAKE2_ParameterBlock< false > | ParameterBlock
Public Types inherited from BLAKE2_Base< word32, false >
typedef BLAKE2_State< word32, T_64bit > | State
typedef BLAKE2_ParameterBlock< T_64bit > | ParameterBlock
typedef SecBlock< State, AllocatorWithCleanup< State, true > > | AlignedState
typedef SecBlock< ParameterBlock, AllocatorWithCleanup< ParameterBlock, true > > | AlignedParameterBlock
Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...

## Public Member Functions

| BLAKE2s (bool treeMode=false, unsigned int digestSize=DIGESTSIZE)
| Construct a BLAKE2s hash. More...
| BLAKE2s (const byte *key, size_t keyLength, const byte *salt=NULL, size_t saltLength=0, const byte *personalization=NULL, size_t personalizationLength=0, bool treeMode=false, unsigned int digestSize=DIGESTSIZE)
| Construct a BLAKE2s hash. More...
Public Member Functions inherited from BLAKE2_Base< word32, false >
std::string | AlgorithmName () const
| Retrieve the object's name. More...
unsigned int | DigestSize () const
| Provides the digest size of the hash. More...
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
void | Update (const byte *input, size_t length)
| Updates a hash with additional input. More...
void | Restart ()
| Restart the hash. More...
void | Restart (const BLAKE2_ParameterBlock< T_64bit > &block, const word32 counter[2])
| Restart a hash with parameter block and counter. More...
void | SetTreeMode (bool mode)
| Set tree mode. More...
bool | GetTreeMode () const
| Get tree mode. More...
void | TruncatedFinal (byte *hash, size_t size)
| Computes the hash of the current message. More...
Public Member Functions inherited from SimpleKeyingInterfaceImpl< MessageAuthenticationCode, BLAKE2_Info< T_64bit > >
size_t | MinKeyLength () const
| The minimum key length used by the algorithm. More...
size_t | MaxKeyLength () const
| The maximum key length used by the algorithm. More...
size_t | DefaultKeyLength () const
| The default key length used by the algorithm. More...
size_t | GetValidKeyLength (size_t keylength) const
| Provides a valid key length for the algorithm. More...
SimpleKeyingInterface::IV_Requirement | IVRequirement () const
| The default IV requirements for the algorithm. More...
unsigned int | IVSize () const
| The default initialization vector length for the algorithm. More...
Public Member Functions inherited from SimpleKeyingInterface
virtual bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length. More...
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object. More...
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object. More...
bool | IsResynchronizable () const
| Determines if the object can be resynchronized. More...
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs. More...
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs. More...
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs returns whether the object can use structured IVs, for example a counter (in addition to ones returned by GetNextIV), false otherwise.
unsigned int | DefaultIVLength () const
| Provides the default size of an IV. More...
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV. More...
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV. More...
virtual void | Resynchronize (const byte *iv, int ivLength=-1)
| Resynchronize with an IV. More...
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual unsigned int | BlockSize () const
| Provides the block size of the compression function. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Additional Inherited Members

Static Public Member Functions inherited from BLAKE2_Base< word32, false >
static const char * | StaticAlgorithmName ()
| Retrieve the static algorithm name. More...
Static Public Attributes inherited from BLAKE2_Base< word32, false >
static const int | DEFAULT_KEYLENGTH
static const int | MIN_KEYLENGTH
static const int | MAX_KEYLENGTH
static const int | DIGESTSIZE
static const int | BLOCKSIZE
static const int | SALTSIZE
static const int | PERSONALIZATIONSIZE

## Detailed Description

The BLAKE2s cryptographic hash function.

BLAKE2s can function as both a hash and keyed hash. If you want only the hash, then use the BLAKE2s constructor that accepts no parameters or digest size. If you want a keyed hash, then use the constuctor that accpts the key as a parameter. Once a key and digest size are selected, its effectively immutable. The Restart() method that accepts a ParameterBlock does not allow you to change it.

See also
  Aumasson, Neves, Wilcox-O'Hearn and Winnerlein's BLAKE2: simpler, smaller, fast as MD5 (2013.01.29).

Since
  Crypto++ 5.6.4

Definition at line 285 of file blake2.h.

## Constructor & Destructor Documentation

## BLAKE2s() [1/2]

BLAKE2s::BLAKE2s | ( | bool | treeMode = `false`,
|  | unsigned int | digestSize = `DIGESTSIZE`
| ) |  |

inline

Construct a BLAKE2s hash.

Parameters

  digestSize | the digest size, in bytes
  treeMode | flag indicating tree mode

Definition at line 295 of file blake2.h.

## BLAKE2s() [2/2]

BLAKE2s::BLAKE2s | ( | const byte * | key,
|  | size_t | keyLength,
|  | const byte * | salt = `NULL`,
|  | size_t | saltLength = `0`,
|  | const byte * | personalization = `NULL`,
|  | size_t | personalizationLength = `0`,
|  | bool | treeMode = `false`,
|  | unsigned int | digestSize = `DIGESTSIZE`
| ) |  |

inline

Construct a BLAKE2s hash.

Parameters

  key | a byte array used to key the cipher
  keyLength | the size of the byte array
  salt | a byte array used as salt
  saltLength | the size of the byte array
  personalization | a byte array used as prsonalization string
  personalizationLength | the size of the byte array
  treeMode | flag indicating tree mode
  digestSize | the digest size, in bytes

Definition at line 306 of file blake2.h.

The documentation for this class was generated from the following file:

- blake2.h